#ifndef BOUNDARYELEMENTLEVELSETDIST_H
#define BOUNDARYELEMENTLEVELSETDIST_H

#include "ElInfo.h"
#include "FixVec.h"
#include "ElementLevelSet.h"
#include "BoundaryElementDist.h"

using namespace AMDiS;

class BoundaryElementLevelSetDist : public BoundaryElementDist
{
public:

  BoundaryElementLevelSetDist(ElementLevelSet *elLS_, int dim_)
    : BoundaryElementDist(elLS_, dim_)
  {}

  /**
   * Calculates distance from the interface for all vertices of a boundary 
   * element.
   * Distance is here the value of the level set function at boundary
   * vertices..
   *
   * Return value: Status of element elInfo.
   */
  int calcDistOnBoundaryElement(ElInfo *elInfo,
				FixVec<double, VERTEX> &dVec);
};

#endif  // BOUNDARYELEMENTLEVELSETDIST_H
